import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class ArraySetTests {
    @Test
    public void simpleSizeTest() {
        ISet<Integer> set = new ArraySet<>();
        set.add(0);
        set.add(0);
        set.add(0);
        set.add(0);
        set.add(0);
        assertEquals(1, set.size(), "repeatedly adding the same element results in it only being added once");
    }

    @Test
    public void simpleToStringTest() {
        ISet<Integer> set = new ArraySet<>();
        assertEquals("[]", set.toString(), "adding consecutive values results in the right string output");

        set.add(0);
        assertEquals("[0]", set.toString(), "adding consecutive values results in the right string output");

        set.add(1);
        assertEquals("[0, 1]", set.toString(), "adding consecutive values results in the right string output");

        set.add(2);
        assertEquals("[0, 1, 2]", set.toString(), "adding consecutive values results in the right string output");

        set.add(3);
        assertEquals("[0, 1, 2, 3]", set.toString(), "adding consecutive values results in the right string output");
    }

    @Test
    public void peopleTest() {
        ISet<Person> set = new ArraySet<>();
        assertEquals("[]", set.toString(), "adding person values results in the right string output");
        Person p = new Person("Adam");
        set.add(p);
        assertEquals("[Adam]", set.toString(), "adding person values results in the right string output");

        set.add(p);
        assertEquals("[Adam]", set.toString(), "adding person values results in the right string output");
    }
}